<?php

	#Actions & Hooks
	#Updates info
	add_filter('plugins_api', 'ckrd_update_plugin_info', 20, 3);
	#Test after update
	add_action('upgrader_process_complete', 'ckrd_after_plugin_update', 10, 2);
	#Update checker
	add_filter('site_transient_update_plugins', 'ckrd_push_plugin_update');
	
	

	function ckrd_update_plugin_info($res, $action, $args){
		
		if('plugin_information' !== $action){
			return false;
		}
		
		$plugin_slug = 'cookiehint-wp'; 
		
		if($plugin_slug !== $args->slug){
			return false;
		}
		
		if(false == $remote = get_transient('redim_update_'.$plugin_slug)){
			
			$remote = wp_remote_get('https://www.redim.de/jupdates/cookiehint-wp.json', [
					'timeout' => 10,
					'headers' => [
						'Accept' => 'application/json',
					],
				]
			);
			
			if(!is_wp_error($remote) && isset($remote['response']['code']) && $remote['response']['code'] == 200 && !empty($remote['body'])){
				set_transient('redim_update_'.$plugin_slug, $remote, 43200);
			}
			
		}
		
		if(!is_wp_error($remote) && isset($remote['response']['code']) && $remote['response']['code'] == 200 && !empty($remote['body'])){
			
			$remote = json_decode($remote['body']);
			$res    = new stdClass();
			
			$res->name     = $remote->name;
			$res->slug     = $plugin_slug;
			$res->version  = $remote->version;
			$res->tested   = $remote->tested;
			$res->requires = $remote->requires;
			$res->author   = '<a href="https://www.redim.de/">Redim GmbH</a>';
			$res->download_link = $remote->download_url;
			$res->trunk         = $remote->download_url;
			$res->requires_php  = '5.3';
			$res->last_updated  = $remote->last_updated;
			$res->sections      = [
				'description'  => $remote->sections->description,
				'installation' => $remote->sections->installation,
				'changelog'    => $remote->sections->changelog
			];
			$res->banners       = [
				'low'  => $remote->banners->low,
				'high' => $remote->banners->high,
			];
			
			if(!empty($remote->sections->screenshots)){
				$res->sections['screenshots'] = $remote->sections->screenshots;
			}
			

			return $res;
			
		}
		
		return false;
		
	}
	
	
	function ckrd_push_plugin_update($transient){
		if ( !is_admin() ) {
			return;
		}
		
		if(empty($transient->checked)){
			return $transient;
		}
		
		if(false == $remote = get_transient('redim_upgrade_cookiehint')){
			
			$remote = wp_remote_get('https://www.redim.de/jupdates/cookiehint-wp.json', [
					'timeout' => 10,
					'headers' => [
						'Accept' => 'application/json',
					],
				]
			);
			
			if(!is_wp_error($remote) && isset($remote['response']['code']) && $remote['response']['code'] == 200 && !empty($remote['body'])){
				set_transient('redim_upgrade_cookiehint', $remote, 43200);
			}
			
		}
		
		
			$rd_cookiehint_plugin_data    = get_plugin_data(plugin_dir_path(__FILE__).'cookiehint-wp.php');
			
			$rd_cookiehint_plugin_version = $rd_cookiehint_plugin_data['Version'];

			
		if($remote){
			
			$remote = json_decode($remote['body']);
			
			if($remote && version_compare($rd_cookiehint_plugin_version, $remote->version, '<') && version_compare($remote->requires, get_bloginfo('version'), '<')){
				$res                               = new stdClass();
				$res->slug                         = 'cookiehint-wp';
				$res->plugin                       = 'cookiehint-wp/cookiehint-wp.php'; 
				$res->new_version                  = $remote->version;
				$res->tested                       = $remote->tested;
				$res->package                      = $remote->download_url;
				$transient->response[$res->plugin] = $res;
			}
			
		}
		
		return $transient;
	}
	
	
	function ckrd_after_plugin_update($upgrader_object, $options){
		
		if($options['action'] == 'update' && $options['type'] === 'plugin'){
			delete_transient('redim_upgrade_cookiehint');
		}
	}